import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{
    final static int START_X = 50;
    final static int START_Y = 750;
    static boolean moving;
    static int clickx = 0;
    static int clicky = 0;
    Vertical vertical;
    Horizontal horizontal;
    Both both;
    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(1000, 800, 1); 
        Greenfoot.setSpeed(48);
        moving = false;
        vertical = new Vertical();
        addObject (vertical, START_X, START_Y);
        horizontal = new Horizontal();
        addObject (horizontal, START_X, START_Y);
        both = new Both();
        addObject (both, START_X, START_Y);
    }

    public void act() {
        if (!moving) {
            // Not moving
            if (Greenfoot.mousePressed(this)) {
                MouseInfo info = Greenfoot.getMouseInfo();
                clickx = info.getX();
                clicky = info.getY();

                // Set the velocity on the basis of how far away from the starting location the click
                // is, but reduce by some factor otherwise it's too fast.
                horizontal.v = (clickx - START_X) / 50;
                vertical.v = (clicky - START_Y) / 10;
                moving = true;
            }
        }
        else {
            // Moving
            both.setLocation(horizontal.getX(), vertical.getY());
            if (vertical.getY() > START_Y) {
                // The vertical object has now reached the ground so reset its location and stop motion.
                vertical.setLocation(START_X, START_Y);
                both.setLocation(horizontal.getX(), vertical.getY());
                moving = false;
                Greenfoot.delay(100);
                reset();
            }
            // The "both" object takes its x and y from each of the other objects.
        }

    }
    void reset() {
        vertical.setLocation(START_X, START_Y);
        horizontal.setLocation(START_X, START_Y);
        both.setLocation(START_X, START_Y);

    }
}
